//+------------------------------------------------------------------+ 
//|   TRO_Reversal_Indicator                                         | 
//|                                                                  | 
//|   Copyright  2009, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/fx/ as your forex broker  |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 
#property  copyright "Copyright  2009, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 


#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Blue

#property indicator_width1 1
#property indicator_width2 1


extern bool   Send.Mail      = false ;
extern bool   Sound.Alert    = true ;
//----
extern color color1 = Red;
extern color color2 = Blue;

extern int myWingDingUp  = 217 ;
extern int myWingDingDn  = 218 ;
extern int myLineWidth = 0;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
 

//----
int ExtCountedBars=0;

double HC[],LC[];

double top, bottom;

datetime Trigger ;
 
bool MainAlertLong, MainAlertShort ; 

int    digits, period  ; 
string symbol, tChartPeriod ;  
double point;

//|------------------------------------------------------------------|
int init()
  {
  
   period       =  Period() ;    
   symbol       =  Symbol() ;
   digits       =  Digits ;   
   point        =  Point ;
  
//---- indicators
   SetIndexStyle(0,DRAW_ARROW,0,myLineWidth,color1); 
   SetIndexArrow(0,myWingDingDn); 
   SetIndexBuffer(0,ExtMapBuffer1); 
   SetIndexEmptyValue(0,0.0); 
   
   SetIndexStyle(1,DRAW_ARROW,0,myLineWidth,color2);  
   SetIndexArrow(1,myWingDingUp); 
   SetIndexBuffer(1,ExtMapBuffer2); 
   SetIndexEmptyValue(1,0.0); 
   
//---- initialization done
    TRO() ;
   return(0);
  } 
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
 TRO() ;
   
//----
   return(0);
  } 

//+------------------------------------------------------------------+
int start()
  {
  
   ArrayResize(HC, Bars) ;  
   ArrayResize(LC, Bars) ;

         
   double haOpen, haHigh, haLow, haClose;
   if(Bars<=10) return(0);
   ExtCountedBars=IndicatorCounted();
//---- check for possible errors
   if (ExtCountedBars<0) return(-1);
//---- last counted bar will be recounted
   if (ExtCountedBars>0) ExtCountedBars--;
   int pos=Bars-ExtCountedBars-1;
   while(pos>=0)
   {
    
      haOpen  = Open[pos] ;
      haClose = Close[pos] ;
      haHigh  = High[pos];
      haLow   = Low[pos];
      
      HC[pos] = haHigh  - haClose ;
      LC[pos] = haClose - haLow  ;

      if (HC[pos] > HC[pos+1]  && Close[pos] > Close[pos+1] && haClose > haOpen && Close[pos+1] > Open[pos+1] )
        {
         ExtMapBuffer1[pos] = haHigh;
         ExtMapBuffer2[pos] = 0;                
        } 
      else
      if (LC[pos] > LC[pos+1]  && Close[pos] < Close[pos+1] && haClose < haOpen && Close[pos+1] < Open[pos+1] )
        {
         ExtMapBuffer1[pos] = 0;
         ExtMapBuffer2[pos] = haLow;         
        } 
      else  
        {
         ExtMapBuffer1[pos] = 0 ;
         ExtMapBuffer2[pos] = 0 ;         
        }   // if   
            
 	   pos--;
   }// while
     
    MainAlertShort = false ;
    MainAlertLong  = false ;
    
     
    if(ExtMapBuffer1[0] > 0 ) {MainAlertShort = true ; }  
    if(ExtMapBuffer2[0] > 0 ) {MainAlertLong  = true ; }  
         
if ( Trigger != Time[0] ) 
{
  if( Sound.Alert )
  {
    if( MainAlertLong  ) { Trigger = Time[0] ; Alert(symbol,"  ",  " Reversal Long " + DoubleToStr(Close[0] ,digits)); }
    if( MainAlertShort ) { Trigger = Time[0] ; Alert(symbol,"  ",  " Reversal Short "+ DoubleToStr(Close[0] ,digits)); }     
  }
  
  if( Send.Mail )
  {
    if( MainAlertLong  ) { Trigger = Time[0] ; SendMail(symbol,  "Reversal Long "); }
    if( MainAlertShort ) { Trigger = Time[0] ; SendMail(symbol,  "Reversal Short "); }     
  }  
  

}
//----
   return(0);
  }
  

//+------------------------------------------------------------------+
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}  
//+------------------------------------------------------------------+
/*
   ,range[], size[]
   
   ArrayResize(range, Bars) ;
   ArrayResize(size, Bars) ;
 
      top     = MathMax( haOpen, haClose) ;
      bottom  = MathMin( haOpen, haClose) ;    
      
      range[pos] = haHigh - haLow ;
      size[pos]  = top - bottom ;
        
    Comment( 
 
    "HC[0]=", DoubleToStr(HC[0], Digits), "\n", 
    "LC[0]=", DoubleToStr(LC[0], Digits), "\n",
    "") ;         
     
     
*/     